class Easydb4MigrationPlugin.KlosterkammerHannover extends Easydb4MigrationPlugin
	name: ->
		"klosterkammer-hannover"

	payload: (filename, json, update, store_file) ->

		tag_refs_by_name =
			"Ausleihe": "ausleihe"
			"Inventur": "inventur"
			"Leihverkehr": "leihverkehr"
			"Maßnahme": "massnahme"
			"Umgebungsdaten": "umgebungsdaten"
			"Zustand": "zustand"

		if json.import_type == "tags"
			# Tags for sammlungsobjekte__objs.typus

			tags_typus = []
			for name, ref of tag_refs_by_name
				console.debug "tag name:", name, "=> reference:", ref
				tags_typus.push
					tag:
						shortname: "typus:" + ref
						reference: "typus:" + ref
						displayname:
							"de-DE": name
						is_default: false
						enabled: true
						displaytype: "search"
						type: "individual"

			json.tags.push
				taggroup:
					shortname: "typus"
					reference: "typus"
					type: "checkbox"
					displayname:
						"de-DE": "Typus"
				_tags: tags_typus

			return

		# for objects of type "sammlungsobjekte": assign tags according to column "sammlungsobjekte__objs.typus"

		if json.import_type != "db"
			return

		if json.objecttype != "sammlungsobjekte"
			return

		# nested table names (suffix):
		objs__suffixes = [
			"objs_1806",
			"objs_1812",
			"objs_1815",
			"objs_1861",
			"objs_1963",
			"objs_2378",
			"objs_1713"
		]

		for obj in json.objects
			new_tag_refs = []
			for suffix in objs__suffixes
				for sammlungsobjekte__objs in obj.sammlungsobjekte["_nested:sammlungsobjekte__" + suffix] or []
					typus = sammlungsobjekte__objs.typus
					if not typus
						continue

					# collect tag reference for typus, add into array if not yet included
					tag_ref = tag_refs_by_name[typus]
					if not tag_ref
						continue
					if new_tag_refs.includes("typus:" + tag_ref)
						continue

					new_tag_refs.push("typus:" + tag_ref)
					console.debug "new value for 'typus' in '_nested:sammlungsobjekte__" + suffix + "' =>", new_tag_refs

			if new_tag_refs.length == 0
				continue

			if not obj._tags
				obj._tags = []
			for tag_ref in new_tag_refs
				obj._tags.push
					"lookup:_id":
						reference: tag_ref

		return

ez5.session_ready =>
	Easydb4Migration.plugins.registerPlugin(Easydb4MigrationPlugin.KlosterkammerHannover)
